
# !!! DO NOT MODIFY THIS FILE !!!
#
# This file was autogenerated `defineVMStruct.py`.
# If you need to modify this struct modify the definition in that file.

import ctypes

class Chip8Regs(ctypes.Structure):
    _pack_   = 1
    _fields_ = [
        ('hexes', ctypes.c_uint8 * 80), # Hexsprite pointer
        ('VRAM', ctypes.c_uint8 * 0x100), # Video memory
        ('stack', ctypes.c_uint16 * 0x10), # Address stack
        ('V', ctypes.c_uint8 * 0x10), # General purpose registers
        ('SP', ctypes.c_uint8), # Stack pointer
        ('PC', ctypes.c_uint16), # Program counter
        ('I', ctypes.c_uint16), # Address register
        ('DT', ctypes.c_uint8), # Delay timer
        ('ST', ctypes.c_uint8), # Sound timer
        ('W', ctypes.c_uint8), # Wait register
        ('K', ctypes.c_uint16), # Key IO registers
        ('seed', ctypes.c_uint8), # Seed for RNG
        ('wait', ctypes.c_uint8), # Chip-8 in wait mode
        ('clock', ctypes.c_uint64), # Time since simulation began
        ('freq', ctypes.c_uint16), # Frequency as a factor of 60Hz
        ('diffX', ctypes.c_uint8), # VRAM diff X position
        ('diffY', ctypes.c_uint8), # VRAM diff Y position
        ('diffSize', ctypes.c_uint8), # VRAM diff size
        ('diffClear', ctypes.c_uint8), # Indicate a CLS instruction
        ('diffSkip', ctypes.c_uint8), # Flag to indicate a skipable DRW instruction
        ('quirks', ctypes.c_uint8), # Flag to indicate quirky instructions for specific ROMs
    ]

class Chip8VMStruct(ctypes.Union):
    _pack_      = 1
    _anonymous_ = ['_regs']
    _fields_    = [
        ('RAM',   ctypes.c_uint8 * 0x1000),
        ('_regs', Chip8Regs),
    ]
